%----------------------------------------------------
% >>>Sistemi avanzati per il riconoscimento<<<
%        3 dicembre 2015
%    - TAPPMOG -  Completo
%----------------------------------------------------
%% Script TAPPMOG

file_id     =   '.\WavingTrees\'
output_id   =   '.'
num_comps   =   3;
alpha       =   0.01;
T           =   0.9;
init_w      =   0.005;
init_std    =   12;
min_p_std   =   4;
max_p_std   =   18;

 SGimages(file_id,output_id,num_comps,alpha,T,init_w,init_std,min_p_std,max_p_std); 




%Esercizio 1: mappare il codice di TAPPMOG visto a lezione con le parti di
%codice MATLAB

%Esercizio 2:Regolare i parametri e osservare il risultato in termini
%qualitativi

%Esercizio 3:analizzare i risultati in termini quantitativi, cercando la
%parametrizzazione che massimizzi l'accuratezza del metodo per tutte e tre
%le sequenze (presa una per volta); invece dell'accuratezza, cosa si deve
%usare?




% GT = rgb2gray(imread('.\WavingTrees\hand_segmented_00247.bmp'))>128;
% MY = load('0247.mat');
% MYGT = MY.Track;
% 
% MYGT = MYGT.*-2;
% res = MYGT + GT;
% confu(1,1) = sum(res(:)==-1);% TP
% confu(1,2) = sum(res(:)==1);% FP
% confu(2,2) = sum(res(:)==0);% TN
% confu(2,1) = sum(res(:)==-2);% FN
% 
% precision = confu(1,1)/sum(confu(1,:));
% recall = confu(1,1)/sum(confu(:,1));

% al=0;
% for alpha = [0.001 0.01]
%     al = al+1;
%     nu=0;
%     for num_comps = [3,5]
%         nu=nu+1;
%         TT=0;
%         for T= [0.8 0.9]
%             TT=TT+1;
%          fprintf('test con alpha=%1.3f|num_comps=%i|T=%1.3f\n',alpha,num_comps,T);   
%         
%               SGimagesNOFIGURE(file_id,output_id,num_comps,alpha,T,init_w,init_std,min_p_std,max_p_std);
%         GT = rgb2gray(imread('.\WavingTrees\hand_segmented_00247.bmp'))>128;
%         MY = load('0247.mat');
%         MYGT = MY.Track;
%         
%         MYGT = MYGT.*-2;
%         res = MYGT + GT;
%         confu(1,1) = sum(res(:)==-1);% TP
%         confu(1,2) = sum(res(:)==1);% FP
%         confu(2,2) = sum(res(:)==0);% TN
%         confu(2,1) = sum(res(:)==-2);% FN
%         
%         precision(al,nu,TT) = confu(1,1)/sum(confu(1,:));
%         recall(al,nu,TT) = confu(1,1)/sum(confu(:,1));
%         
%         fprintf('precision=%1.3f|recall=%1.3f\n',precision(al,nu,TT),recall(al,nu,TT));
%         
%         end
%     end
% end

%Esercizio 4: visualizzare a schermo non piu' solo la maschera binaria di
%foreground, ma anche il peso totale di confidenza catturato con
%l'operazione di confronto con la soglia

%Esercizio 5: definire la "migliore" soglia T utilizzando la curva ROC,
%fissando a priori tutti gli altri parametri.
% alpha=0.010;
% num_comps=5;
% SGimagesNOFIGURE(file_id,output_id,num_comps,alpha,T,init_w,init_std,min_p_std,max_p_std);
% MY = load('0247.mat');
% confi = MY.Sum(:);
% [X,Y,Th,AUC,OPTROCPT] = perfcurve(double(GT(:)),double(confi),1);
% figure; plot(X,Y)
% xlabel('False Positive Rate (FPR)')
% ylabel('True Positive Rate (TPR)')
% title('ROC')
% %Trovo la soglia
% index = find(X==OPTROCPT(1)&Y==OPTROCPT(2));
% BestT = Th(index) %migliore soglia
% SGimages(file_id,output_id,num_comps,alpha,BestT,init_w,init_std,min_p_std,max_p_std); 